/* 
	Corsix's N Level Generator
    Copyright (C) 2007 Peter Cawley

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _LUA_GENERATOR_H_
#define _LUA_GENERATOR_H_

extern "C" {
#include <lua.h>
}
#include "frmMain.h"

class LuaGenerator
{
public:
	LuaGenerator();
	~LuaGenerator();

	bool init(const char* sFilename, frmMain* pDestination);

	void setSpeed(int iSpeed);

	bool generate(frmMain* pDestination);

	const wchar_t* getErrorDetail();

protected:
	lua_State* m_pL;
	lua_State* m_pWorkerThread;

	wchar_t* m_sLastError;

	void _setLastError(const char* sWhat, const char* sDetail);

	bool _catchLoadErr(lua_State *L, int iCode);
	bool _catchPCallErr(lua_State *L, int iCode);
};

#endif