/* 
	Corsix's N Level Generator
    Copyright (C) 2007 Peter Cawley

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _FRM_MAIN_H_
#define _FRM_MAIN_H_

#include "wx/wxprec.h"
#ifdef __BORLANDC__
    #pragma hdrstop
#endif
#ifndef WX_PRECOMP
    #include "wx/app.h"
    #include "wx/log.h"
    #include "wx/frame.h"
    #include "wx/panel.h"
    #include "wx/timer.h"
    #include "wx/utils.h"
    #include "wx/menu.h"
    #include "wx/msgdlg.h"
    #include "wx/textdlg.h"
    #include "wx/filedlg.h"
    #include "wx/choicdlg.h"
    #include "wx/button.h"
    #include "wx/textctrl.h"
    #include "wx/listbox.h"
    #include "wx/sizer.h"
#endif
#include "wx/txtstrm.h"
#include "wx/numdlg.h"
#include "wx/ffile.h"
#include "wx/process.h"
#include "wx/mimetype.h"

#include "wx/statbox.h"
#include "Terrain.h"

class BitmapControl : public wxPanel
{
public:
	BitmapControl(wxWindow* pParent, wxBitmap& bmpBitmap);

	void OnErase(wxEraseEvent& event);
	void OnPaint(wxPaintEvent& event);

protected:
	wxBitmap& m_bmpBitmap;

private:
	DECLARE_EVENT_TABLE()
};

class frmMain : public wxFrame
{
public:
    frmMain(const wxString& title, const wxPoint& pos, const wxSize& size);

	enum
	{
		IDC_Generate = wxID_HIGHEST + 1,
		IDC_GenerateSlowly,
		IDC_CopyData,
		IDC_AddUserlevel
	};

	void setData(const char* sNewData);

	void OnGenerate(wxCommandEvent& e);
	void OnGenerateSlow(wxCommandEvent& e);
	void OnCopyData(wxCommandEvent& e);
	void OnAddUserlevel(wxCommandEvent& e);

	inline Terrain& getTerrain() {return m_oTerrain;}

	inline wxTextCtrl* getNameTextbox() {return m_txtMapName;}
	inline wxTextCtrl* getAuthorTextbox() {return m_txtMapAuthor;}

private:
	BitmapControl* m_pPreviewWindow;
	wxButton* m_btnGenerate;
	wxButton* m_btnGenerateSlow;
	wxTextCtrl* m_txtMapName;
	wxTextCtrl* m_txtMapAuthor;
	wxTextCtrl* m_txtMapData;
	Terrain m_oTerrain;
	wxBitmap m_bmpTerrain;

	bool _renderTerrainToBitmap();

    DECLARE_EVENT_TABLE()
};

#endif